diff --git a/wcs/qommon/admin/menu.py b/wcs/qommon/admin/menu.py
index 7898b060..90b16a7d 100644
--- a/wcs/qommon/admin/menu.py
+++ b/wcs/qommon/admin/menu.py
@@ -45,12 +45,12 @@ def _find_vc_version():
         if os.path.exists('/etc/debian_version'):
             # debian case
             try:
-                process = subprocess.Popen(
+                with subprocess.Popen(
                     ['dpkg', '-l', package], stdout=subprocess.PIPE, stderr=subprocess.STDOUT
-                )
-                version = process.communicate()[0].splitlines()[-1].split()[2]
-                if process.returncode == 0:
-                    return "%s %s (Debian)" % (package, version.decode())
+                ) as process:
+                    version = process.communicate()[0].splitlines()[-1].split()[2]
+                    if process.returncode == 0:
+                        return "%s %s (Debian)" % (package, version.decode())
             except Exception:
                 pass
         return None
@@ -66,13 +66,13 @@ def _find_vc_version():
 
     if os.path.exists(os.path.join(srcdir, '.git')):
         try:
-            process = subprocess.Popen(
+            with subprocess.Popen(
                 ['git', 'log', '--pretty=oneline', '-1'], stdout=subprocess.PIPE, cwd=srcdir
-            )
-            output = process.communicate()[0]
+            ) as process:
+                output = process.communicate()[0]
             rev = str(output.split()[0].decode('ascii'))
-            process = subprocess.Popen(['git', 'branch'], stdout=subprocess.PIPE, cwd=srcdir)
-            output = process.communicate()[0]
+            with subprocess.Popen(['git', 'branch'], stdout=subprocess.PIPE, cwd=srcdir) as process:
+                output = process.communicate()[0]
             starred_line = [x for x in output.splitlines() if x.startswith(b'*')][0]
             branch = str(starred_line.split()[1].decode('ascii'))
             url = "https://repos.entrouvert.org/%s.git/commit/?id=%s" % (package, rev)
diff --git a/wcs/qommon/form.py b/wcs/qommon/form.py
index e231e304..5ec673c0 100644
--- a/wcs/qommon/form.py
+++ b/wcs/qommon/form.py
@@ -660,7 +660,8 @@ class UploadedFile:
         file_path = self.build_file_path()
         if not os.path.exists(self.dir_path()):
             os.mkdir(self.dir_path())
-        open(file_path, 'wb').write(content)
+        with open(file_path, 'wb') as f:
+            f.write(content)
 
     def dir_path(self):
         return os.path.join(get_publisher().app_dir, self.directory)
@@ -669,7 +670,7 @@ class UploadedFile:
         return os.path.join(get_publisher().app_dir, self.directory, self.filename)
 
     def get_file(self):
-        return open(self.build_file_path(), 'rb')
+        return open(self.build_file_path(), 'rb')  # pylint: disable=consider-using-with
 
     def get_content(self):
         return self.get_file().read()
diff --git a/wcs/qommon/misc.py b/wcs/qommon/misc.py
index 28212940..127b240c 100644
--- a/wcs/qommon/misc.py
+++ b/wcs/qommon/misc.py
@@ -679,8 +679,7 @@ def get_thumbnail(filepath, content_type=None):
         except subprocess.CalledProcessError:
             raise ThumbnailError()
     else:
-        fp = open(filepath, 'rb')
-
+        fp = open(filepath, 'rb')  # pylint: disable=consider-using-with
     try:
         image = Image.open(fp)
         try:
diff --git a/wcs/qommon/ods.py b/wcs/qommon/ods.py
index 4c18efe9..614703a6 100644
--- a/wcs/qommon/ods.py
+++ b/wcs/qommon/ods.py
@@ -157,22 +157,21 @@ class Workbook:
         return ET.tostring(self.get_content_node(), 'utf-8')
 
     def save(self, output):
-        z = zipfile.ZipFile(output, 'w')
-        z.writestr('content.xml', self.get_content())
-        z.writestr('styles.xml', self.get_styles())
-        z.writestr('mimetype', 'application/vnd.oasis.opendocument.spreadsheet')
-        z.writestr(
-            'META-INF/manifest.xml',
-            '''<?xml version="1.0" encoding="UTF-8"?>
-<manifest:manifest xmlns:manifest="urn:oasis:names:tc:opendocument:xmlns:manifest:1.0">
- <manifest:file-entry manifest:full-path="/" manifest:media-type="application/vnd.oasis.opendocument.spreadsheet"/>
- <manifest:file-entry manifest:full-path="styles.xml" manifest:media-type="text/xml"/>
- <manifest:file-entry manifest:full-path="content.xml" manifest:media-type="text/xml"/>
- <manifest:file-entry manifest:full-path="META-INF/manifest.xml" manifest:media-type="text/xml"/>
- <manifest:file-entry manifest:full-path="mimetype" manifest:media-type="text/plain"/>
-</manifest:manifest>''',
-        )
-        z.close()
+        with zipfile.ZipFile(output, 'w') as z:
+            z.writestr('content.xml', self.get_content())
+            z.writestr('styles.xml', self.get_styles())
+            z.writestr('mimetype', 'application/vnd.oasis.opendocument.spreadsheet')
+            z.writestr(
+                'META-INF/manifest.xml',
+                '''<?xml version="1.0" encoding="UTF-8"?>
+    <manifest:manifest xmlns:manifest="urn:oasis:names:tc:opendocument:xmlns:manifest:1.0">
+     <manifest:file-entry manifest:full-path="/" manifest:media-type="application/vnd.oasis.opendocument.spreadsheet"/>
+     <manifest:file-entry manifest:full-path="styles.xml" manifest:media-type="text/xml"/>
+     <manifest:file-entry manifest:full-path="content.xml" manifest:media-type="text/xml"/>
+     <manifest:file-entry manifest:full-path="META-INF/manifest.xml" manifest:media-type="text/xml"/>
+     <manifest:file-entry manifest:full-path="mimetype" manifest:media-type="text/plain"/>
+    </manifest:manifest>''',
+            )
 
 
 class WorkSheet:
diff --git a/wcs/qommon/storage.py b/wcs/qommon/storage.py
index 2a732c39..6892d021 100644
--- a/wcs/qommon/storage.py
+++ b/wcs/qommon/storage.py
@@ -501,7 +501,7 @@ class StorableObject:
     def get_filename(cls, filename, ignore_errors=False, ignore_migration=False, **kwargs):
         fd = None
         try:
-            fd = open(force_bytes(filename, 'utf-8'), 'rb')
+            fd = open(force_bytes(filename, 'utf-8'), 'rb')  # pylint: disable=consider-using-with
             o = cls.storage_load(fd, **kwargs)
         except IOError:
             if ignore_errors:
diff --git a/wcs/qommon/upload_storage.py b/wcs/qommon/upload_storage.py
index 0eeba392..fdb1955c 100644
--- a/wcs/qommon/upload_storage.py
+++ b/wcs/qommon/upload_storage.py
@@ -42,7 +42,7 @@ class PicklableUpload(Upload):
             return self.__dict__.get('fp')
         elif getattr(self, 'qfilename', None):
             basedir = os.path.join(get_publisher().app_dir, 'uploads')
-            self.fp = open(os.path.join(basedir, self.qfilename), 'rb')
+            self.fp = open(os.path.join(basedir, self.qfilename), 'rb')  # pylint: disable=consider-using-with
             return self.fp
         return None
 
@@ -125,11 +125,10 @@ class UploadStorage:
         upload.__class__ = PicklableUpload
         dirname = os.path.join(get_publisher().app_dir, 'tempfiles')
         filename = os.path.join(dirname, upload.token)
-        fd = open(filename, 'wb')
-        upload.get_file_pointer().seek(0)
-        fd.write(upload.get_file_pointer().read())
-        upload.size = fd.tell()
-        fd.close()
+        with open(filename, 'wb') as fd:
+            upload.get_file_pointer().seek(0)
+            fd.write(upload.get_file_pointer().read())
+            upload.size = fd.tell()
 
     def get_tempfile(self, temp_data):
         value = PicklableUpload(temp_data['orig_filename'], temp_data['content_type'], temp_data['charset'])
@@ -138,7 +137,7 @@ class UploadStorage:
         filename = os.path.join(dirname, temp_data['unsigned_token'])
         value.token = temp_data['token']
         value.file_size = os.path.getsize(filename)
-        value.fp = open(filename, 'rb')
+        value.fp = open(filename, 'rb')  # pylint: disable=consider-using-with
         return value
 
     def save(self, upload):
diff --git a/wcs/qommon/x509utils.py b/wcs/qommon/x509utils.py
index 274a4533..2b42ca5b 100644
--- a/wcs/qommon/x509utils.py
+++ b/wcs/qommon/x509utils.py
@@ -45,9 +45,11 @@ def _call_openssl(args):
     Return a tuple made of the return code and the stdout output
     """
     try:
-        process = subprocess.Popen(args=[_openssl] + args, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
-        output = process.communicate()[0]
-        return process.returncode, output
+        with subprocess.Popen(
+            args=[_openssl] + args, stdout=subprocess.PIPE, stderr=subprocess.STDOUT
+        ) as process:
+            output = process.communicate()[0]
+            return process.returncode, output
     except OSError:
         return 1, None
 
diff --git a/wcs/wf/export_to_model.py b/wcs/wf/export_to_model.py
index fa3d5ce6..18f4cb1d 100644
--- a/wcs/wf/export_to_model.py
+++ b/wcs/wf/export_to_model.py
@@ -135,30 +135,28 @@ def transform_opendocument(instream, outstream, process):
     format, parse context.xml with element tree and apply process to its root
     node.
     """
-    zin = zipfile.ZipFile(instream, mode='r')
-    zout = zipfile.ZipFile(outstream, mode='w')
-    new_images = {}
-    assert 'content.xml' in zin.namelist()
-    for filename in zin.namelist():
-        # first pass to process meta.xml, content.xml and styles.xml
-        if filename not in ('meta.xml', 'content.xml', 'styles.xml'):
-            continue
-        content = zin.read(filename)
-        root = ET.fromstring(content)
-        process(root, new_images)
-        content = ET.tostring(root)
-        zout.writestr(filename, content)
-
-    for filename in zin.namelist():
-        # second pass to copy/replace other files
-        if filename in ('meta.xml', 'content.xml', 'styles.xml'):
-            continue
-        if filename in new_images:
-            content = new_images[filename].get_content()
-        else:
+    with zipfile.ZipFile(instream, mode='r') as zin, zipfile.ZipFile(outstream, mode='w') as zout:
+        new_images = {}
+        assert 'content.xml' in zin.namelist()
+        for filename in zin.namelist():
+            # first pass to process meta.xml, content.xml and styles.xml
+            if filename not in ('meta.xml', 'content.xml', 'styles.xml'):
+                continue
             content = zin.read(filename)
-        zout.writestr(filename, content)
-    zout.close()
+            root = ET.fromstring(content)
+            process(root, new_images)
+            content = ET.tostring(root)
+            zout.writestr(filename, content)
+
+        for filename in zin.namelist():
+            # second pass to copy/replace other files
+            if filename in ('meta.xml', 'content.xml', 'styles.xml'):
+                continue
+            if filename in new_images:
+                content = new_images[filename].get_content()
+            else:
+                content = zin.read(filename)
+            zout.writestr(filename, content)
 
 
 def is_opendocument(stream):
diff --git a/wcs/workflows.py b/wcs/workflows.py
index edd102be..4b6416c0 100644
--- a/wcs/workflows.py
+++ b/wcs/workflows.py
@@ -229,7 +229,7 @@ class AttachmentEvolutionPart:
     def get_file_pointer(self):
         if self.filename.startswith('uuid-'):
             return None
-        return open(self.filename, 'rb')
+        return open(self.filename, 'rb')  # pylint: disable=consider-using-with
 
     def __getstate__(self):
         odict = self.__dict__.copy()
-- 
2.30.2

